// 1 uduotis - riavimas

// 39 variantas
// Iriuokite masyvo elementus majimo tvarka irinkimo metodu, kai suriuota dalis formuojama masyvo pradioje.
// Iriuokite masyvo elementus didjimo tvarka terpimo metodu, kai suriuota dalis formuojama masyvo pabaigoje.
// Iriuokite masyvo elementus majimo tvarka burbulo metodu, kai suriuota dalis formuojama masyvo pradioje.

program uzduotis1;

type
    videoteka = record
    pavadinimas : string;
    metai : integer;
    trukme : real;
    ivertinimas : char;
    rodotv : boolean;
end;
    filmai = array[1..20] of videoteka;

// +skaitymas
procedure skaitymas(var f : filmai; var N : integer);
var data : text;
    i : integer;
begin
    randomize;
    assign(data, 'filmai.txt');
    reset(data);
    readln(data, N);
    for i := 1 to N do
    begin
        readln(data, f[i].metai, f[i].trukme, f[i].pavadinimas);
        delete(f[i].pavadinimas,1,1);
        f[i].trukme := f[i].trukme/60;
        f[i].ivertinimas := chr(random(10)+65);
        if random(2)=0 then f[i].rodotv := false else f[i].rodotv := true;
    end;
end;
// -skaitymas

// +selection pagal metus
procedure selection(var f : filmai; var N : integer);
var i, j, min, k, lyg, keit : integer;
    t : videoteka;
begin
    writeln('Rusiuojamas filmu sarasas pagal metus:');
    lyg := 0; keit := 0;
    for i := 1 to N-1 do
        begin
            min:=i;
            for j := i+1 to N do
                begin
                    lyg := lyg+1;
                    if f[j].metai > f[min].metai then
                        begin
                            min := j;
                        end;
                end;
            t := f[i];
            f[i] := f[min];
            f[min] := t;
            keit := keit+1;
            for k:= 1 to N do
                begin
                    write(f[k].metai,' ');
                end;
            writeln;
        end;
  
    writeln(chr(10),'Spausdinamas naujasis filmu sarasas, surusiuotas pagal metus:');
    for i:= 1 to N do
        writeln('"',f[i].pavadinimas,'" ', f[i].metai,'m. ', f[i].trukme:2:2,'h. ',f[i].ivertinimas,' ',f[i].rodotv);
    writeln(chr(10),'BAIGTA. Atlikta ',lyg,' lyginimu ir ',keit,' keitimu',chr(10));
end;
// -selection

// +insertion pagal trukme
procedure insertion(var f : filmai; var N : integer);
var i, j, k, lyg, keit : integer;
    v : videoteka;
begin
    writeln('Rusiuojamas filmu sarasas pagal trukme:');
    lyg := 0; keit := 0;
    for i:= N-1 downto 1 do
        begin
            v := f[i];
            j := i;
            while (j < N) and (f[j+1].trukme < v.trukme) do
                begin
                    f[j] := f[j+1];
                    j := j+1;
                    lyg := lyg+1;
                end;
            f[j] := v;
            keit := keit+1;
            for k := 1 to N do
                begin
                    write(f[k].trukme:2:2,' ');
                end;
            writeln;
end;

    writeln(chr(10),'Spausdinamas naujasis filmu sarasas, surusiuotas pagal trukme:');
    for i:= 1 to N do
        writeln('"',f[i].pavadinimas,'" ', f[i].metai,'m. ', f[i].trukme:2:2,'h. ',f[i].ivertinimas,' ',f[i].rodotv);
    writeln(chr(10),'BAIGTA. Atlikta ',lyg,' lyginimu ir ',keit,' keitimu',chr(10));
end;
// -insertion

// +bubble pagal ivertinimus
procedure bubble(var f : filmai; var N : integer);
var i, j, k, lyg, keit : integer;
    t : videoteka;
begin
    writeln('Rusiuojamas filmu sarasas pagal ivertinimus:');
    lyg := 0; keit := 0;
    for i := N downto 1 do
        for j := N-1 downto 2 do
            begin
                lyg := lyg+1;
                if ord(f[j-1].ivertinimas) < ord(f[j].ivertinimas) then
                    begin
                        t:=f[j-1];
                        f[j-1]:=f[j];
                        f[j]:=t;
                        keit := keit + 1;
                        for k:= 1 to N do
                            begin
                                write(f[k].ivertinimas,' ');
                            end;
                        writeln;
                        
                    end;
            end;
            
    writeln(chr(10),'Spausdinamas naujasis filmu sarasas, surusiuotas pagal ivertinimus:');
    for i:= 1 to N do
        writeln('"',f[i].pavadinimas,'" ', f[i].metai,'m. ', f[i].trukme:2:2,'h. ',f[i].ivertinimas,' ',f[i].rodotv);
    writeln(chr(10),'BAIGTA. Atlikta ',lyg,' lyginimu ir ',keit,' keitimu',chr(10));
end;
// -bubble

// pagrindine
    var i, N : integer;
        f : filmai;
        komanda : char;
begin
    skaitymas(f, N);
    repeat
        writeln('Pasirinkite');
        writeln('1 - jei norite atspausdinti pradini filmu sarasa');
        writeln('2 - jei norite surusiuoti filmus SELECTION metodu pagal isleidimo metus mazejimo tvarka, kai ji formuojama masyvo pradzioje');
        writeln('3 - jei norite surusiuoti filmus INSERTION metodu pagal trukme didejimo tvarka, kai ji formuojama masyvo pabaigoje');
        writeln('4 - jei norite surusiuoti filmus BUBBLE metodu pagal ziurovu ivertinima mazejimo tvarka, kai ji formuojama masyvo pradzioje');
        writeln('0 - jei norite baigti');
        writeln;
        write('pasirinkimas: ');
        readln(komanda);

        case komanda of
            '1' : begin
                    writeln('Spausdinamas pradinis filmu sarasas (pavadinimas, metai, trukme, ivertinimas, rodo TV):');
                    for i:= 1 to N do
                        begin
                            writeln('"',f[i].pavadinimas,'" ', f[i].metai,'m. ', f[i].trukme:2:2,'h. ',f[i].ivertinimas,' ',f[i].rodotv);
                        end;
                    writeln;
                end;
            '2' : selection(f, N);
            '3' : insertion(f, N);
            '4' : bubble(f, N);
            '0' : break;
		end;
        until (komanda = '0');

end.
